/*
 
 File:		IBVASerialPortINPlugIn.m
 
 Contains:	IBVASerialPortINPlugIn
 
 Version:	IBVA V4.5.8 + IBVASerialPortINPlugIn V1.0
 
 Copyright:	masahiro kahata & Psychic Lab Inc. all rights reserved.
 
 File Ownership:
 
 DRI:				masahiro kahata
 
 Contact:			m@psychiclab.net          masahiro@psychiclab.net       contact@psychiclab.net
 Technology:			http://psychiclab.net      http://www.psychiclab.net
 
 Writers:
 
 (cjd)	masahiro kahata
 
 
 
 //
 //
 // this code open for help
 // people who try to change this world more nice way for us specially people who doing ufo, psychic, psychotronics, crop circle, free energy research and open information act.
 // people who is working this way can use this code for there own purpose with no permission from me with there own risk.
 //
 //
 //
 // IBVA code development short history
 //
 // <IBVA V1.0 beta> 17 oct 1987 : start develop IBVA
 // <IBVA V1.6 beta> 21 oct 1988 : pre prototype
 // <IBVA V1.0> 6 nov 1989 : prototype
 // <IBVA V1.0.2> apr 1991 : start to ship in Japan
 // <IBVA V1.0.5> 5 jan 1992 : start to ship in USA
 // <IBVA V1.8.7>  13 feb 1999 : 68K Think Project Manager 7.0.4
 // <IBVA V2.0.9> 23 jan 2000 : starsBrain & brain skyfly
 // <IBVA V2.3.2> 15 dec 2000 : IDE V4.1, CW V6
 // <IBVA V3.0.0> 26 Sep 2003 : new Icon
 // <IBVA V3.5.0> 29 Nov 2003 : start to use XCODE. V1 prototype Bluetooth IBVA
 // <IBVA V3.6.0> 29 Apr 2004 : V2 prototype Bluetooth IBVA
 // <IBVA V4.0.0> 1 Mar 2005 : Core-MIDI 
 // <IBVA V4.1.0> 17 May 2005 : start to ship IBVA4. XCODE1.5
 // <IBVA V4.1.1> 29 July 2005 : XCODE2.0, Tiger
 // <IBVA V4.1.3> 19 Sep 2005 : XCODE2.2. Quartz Composer Plugin
 // <IBVA V4.2.0> 1 March 2006 : V3 prototype Bluetooth IBVA
 // <IBVA V4.2.6> 5 May 2006 : final prototype Bluetooth IBVA
 // <IBVA V4.4.0> 19 Mar 2007 : XCODE2.4.1.  MIDI play with 0.01 second timing with live video and brain wave recording.
 // <IBVA V4.5.4> 26 Oct 2007 : XCODE3. Leopard.
 // <IBVA V4.5.8> 23 Dec 2007 : QC V3 + XCODE3 + Leopard.
 //
 //
 // this source code is based on my over 35 years of ufo, psychic, dream and brain wave interaction experience, dream and brain wave data analysis & research.
 // thanks to 
 // ayumi, masachan-etsuchan, hiyori, l-chi, paras,
 // alien, beings who working for this planet, this stars system and other stars system,
 // hyper space time dimensions + psychic dimension & dream dimension.
 //
 // need more this kind of experience & research.
 //
 // i need more help to keep continue to do this kind of things,
 // i like happy family, easy way and fun to make it. 
 // need psychic healing,,,
 // need experience for dream, remote viewing, telepathy, psychic, 
 // crop circle, ufo and alien abductee, alien implant, etc....
 */ 



/* It's highly recommended to use CGL macros instead of changing the current context for plug-ins that perform OpenGL rendering */
#import <OpenGL/CGLMacro.h>
#include <Carbon/Carbon.h>

#import "IBVASerialPortINPlugIn.h"

#include <GLUT/glut.h>

#define	kQCPlugIn_Name				@"Serial IN"
#define	kQCPlugIn_Description		@"Serial IN.  Output Gain: All Output Gain setup.  Output Mode: Set Output Mode. Direct, Normalize by 64:0..1, Normalize by 255:0..1, Normalize 0..1 by BS1..4 Peak, Normalize 0..1 by BS1..8 Peak. Brain Channel: Set CH1, CH2, CH3, CH4, Coherence 1/2, Coherence 3/4, Coherence 1/3, Coherence 2/4,  Delta BS1, Theta BS2, Alpha BS3, Low Beta BS4, Mid Beta BS5, High Beta BS6, AC BS7, Gamma BS8:  BS Output."


#define true 1
#define false 0




//
extern	int firstTimeRunAplicationX;



int firsttimestartTouchmainloop=1;
int firstTimeRunTouch=1;
//

//
//
//
 

@implementation IBVASerialPortINPlugIn

/* We need to declare the input / output properties as dynamic as Quartz Composer will handle their implementation */
@dynamic 
inputChannel, inputBPSMode, inputDataBitMode, inputUpdate,

outputBS8L, outputBS7L, outputBS6L, outputBS5L, outputBS4L, outputBS3L, outputBS2L, outputBS1L;


/* The "text" property must be synthesized */
@synthesize text;


+ (NSDictionary*) attributes
{
	/* Return the attributes of this plug-in */
	return [NSDictionary dictionaryWithObjectsAndKeys:kQCPlugIn_Name, QCPlugInAttributeNameKey, kQCPlugIn_Description, QCPlugInAttributeDescriptionKey, nil];
}

+ (NSDictionary*) attributesForPropertyPortWithKey:(NSString*)key
{
    NSArray *titlesBrainChannel = [NSArray arrayWithObjects:
								   @"0: CH 1",
								   @"1: CH 2",
								   @"2: CH 3",
								   @"3: CH 4",
								   @"4: CH 1/2 Coherence",
								   @"5: CH 3/4 Coherence",
								   @"6: CH 1/3 Coherence",
								   @"7: CH 2/4 Coherence",
								   nil];
	
    
	NSArray *titlesBPSMode = [NSArray arrayWithObjects:
										 @"Direct",
										 @"Normalize by 64 : 0..1",
										 @"Normalize by 255 : 0..1",
										 @"Normalize 0..1 by BS1..4 Peak",
										 @"Normalize 0..1 by BS1..8 Peak",
										 nil];
	
	
	/* Return the attributes for the plug-in property ports */
	//	if([key isEqualToString:@"inputString"])
	//		return [NSDictionary dictionaryWithObjectsAndKeys:@"Name", QCPortAttributeNameKey, @"Pod", QCPortAttributeDefaultValueKey, nil];
	
	if([key isEqualToString:@"inputChannel"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Brain Channel", QCPortAttributeNameKey, [NSNumber numberWithUnsignedInteger:7], QCPortAttributeMaximumValueKey, [NSNumber numberWithUnsignedInteger:0], QCPortAttributeDefaultValueKey, [NSArray arrayWithArray:titlesBrainChannel], QCPortAttributeMenuItemsKey,  nil];
	
	if([key isEqualToString:@"inputBPSMode"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Output Mode", QCPortAttributeNameKey, [NSNumber numberWithUnsignedInteger:4], QCPortAttributeMaximumValueKey, [NSNumber numberWithUnsignedInteger:0], QCPortAttributeDefaultValueKey, [NSArray arrayWithArray:titlesBPSMode], QCPortAttributeMenuItemsKey,  nil];
	
 	if([key isEqualToString:@"inputDataBitMode"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Output Gain", QCPortAttributeNameKey, [NSNumber numberWithDouble:100.0], QCPortAttributeMaximumValueKey, [NSNumber numberWithDouble:1.0], QCPortAttributeDefaultValueKey, nil];
	if([key isEqualToString:@"inputUpdate"])
		return [NSDictionary dictionaryWithObject:@"Output Update" forKey:QCPortAttributeNameKey];
	
	//
	
	if([key isEqualToString:@"outputBS8L"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Gamma BS8", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputBS7L"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"AC BS7", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputBS6L"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"High Beta BS6", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputBS5L"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Mid Beta BS5", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputBS4L"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Low Beta BS4", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputBS3L"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Alpha BS3", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputBS2L"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Theta BS2", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputBS1L"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Delta BS1", QCPortAttributeNameKey, nil];
	
	
	
	return nil;
}

+ (QCPlugInExecutionMode) executionMode
{
	/* This plug-in is a processor */
	return kQCPlugInExecutionModeProcessor;
}

+ (QCPlugInTimeMode) timeMode
{
	/* This plug-in does not depend on the time (time parameter is completely ignored in the -execute:atTime:withArguments: method) */
	return kQCPlugInTimeModeNone;
}

- (id) init
{
	if(self = [super init]) {
		/* Set a default value for our internal setting */
		self.text = @"Bonjour";
	}
	
//	AddIbvaNotificationObserverX();
	
	return self;
}

- (void) dealloc
{
	/* IMPORTANT: We need to set the property for our internal setting to nil on -dealloc or the property value will leak */
	self.text = nil;
	
	[super dealloc];
}

// + (NSArray*) plugInKeys
// {
//	/* Return the list of KVC keys corresponding to our internal settings */
//	return [NSArray arrayWithObject:@"text"];
// }

// - (QCPlugInViewController*) createViewController
// {
//	/* Create a QCPlugInViewController to handle the user-interface to edit the our internal settings */
//	return [[QCPlugInViewController alloc] initWithPlugIn:self viewNibName:@"SimpleTextSettings"];
// }



- (void)initializeThred
{
	if (firstTimeRunTouch)	{
		[NSThread detachNewThreadSelector:@selector(runSecondarySerialThread:) toTarget:self withObject:nil];
		firstTimeRunTouch=0;
	}
	
	
	//	[self init];
}

- (void)runSecondarySerialThread:(id)ignoredObject;
{
    NSAutoreleasePool *pool;
	
    pool = [[NSAutoreleasePool alloc] init];
	
//   	timerX = [NSTimer timerWithTimeInterval:0.015f target:self selector:@selector(timerUpdate:) userInfo:nil repeats:YES];
//	[[NSRunLoop currentRunLoop] run];
	
    [pool release];
	
}

- (void) timerUpdate : (NSTimer*) sender	{
	
	
	
}




@end





@implementation IBVASerialPortINPlugIn (Execution)



- (BOOL) startExecution:(id<QCPlugInContext>)context
{
	if (firsttimestartTouchmainloop)	{
		
		// 	 	startmainloop();
	//	[self initializeThred];
		firsttimestartTouchmainloop=0;
	}
	
	//
	//
	return YES;
}

- (BOOL) execute:(id<QCPlugInContext>)context atTime:(NSTimeInterval)time withArguments:(NSDictionary*)arguments
{
	
	int mode_value=(int)self.inputBPSMode;
	int mode_valueZ=0;
	int channel_value=(int)self.inputChannel;	// 0=1ch, 1=2ch, 2=3ch, 3=4ch, 4=ch1/ch2 coherence
	
	double PeakVR, PeakFR, PeakVL, PeakFL;
	
    double     eyePeakL, deltaPeakL, thetaPeakL, 
	alphaPeakL, lowbetaPeakL, midbetaPeakL, 
	highbetaPeakL, gammaPeakL, acPeakL;
	
	double powerGain=1.0;
	int i;
	double maxA=0.0;
	
	//
	//
	//	
	//
	//
	
	//
	/*
	if ( self.inputUpdate )	{
		
		gammaPeakLX=self.outputBS8L = (double)(powerGain*gammaPeakL*(float)(self.inputDataBitMode));
		acPeakLX=self.outputBS7L = (double)(powerGain*acPeakL*(float)(self.inputDataBitMode));
		highbetaPeakLX=self.outputBS6L = (double)(powerGain*highbetaPeakL*(float)(self.inputDataBitMode));
		midbetaPeakLX=self.outputBS5L = (double)(powerGain*midbetaPeakL*(float)(self.inputDataBitMode));
		lowbetaPeakLX=self.outputBS4L = (double)(powerGain*lowbetaPeakL*(float)(self.inputDataBitMode));
		alphaPeakLX=self.outputBS3L = (double)(powerGain*alphaPeakL*(float)(self.inputDataBitMode));
		thetaPeakLX=self.outputBS2L = (double)(powerGain*thetaPeakL*(float)(self.inputDataBitMode));
		deltaPeakLX=self.outputBS1L = (double)(powerGain*deltaPeakL*(float)(self.inputDataBitMode));
		
		
		
		
		
	}	// end of if ( self.inputUpdate )
	*/
	//
	
	
	//
	//
	return YES;
}



@end








