/*
 
 File:		IBVASerialPortOutPlugIn.m
 
 Contains:	IBVASerialPortOutPlugIn
 
 Version:	IBVA V4.5.8 + IBVASerialPortOutPlugIn V1.0
 
 Copyright:	masahiro kahata & Psychic Lab Inc. all rights reserved.
 
 File Ownership:
 
 DRI:				masahiro kahata
 
 Contact:			m@psychiclab.net          masahiro@psychiclab.net       contact@psychiclab.net
 Technology:			http://psychiclab.net      http://www.psychiclab.net
 
 Writers:
 
 (cjd)	masahiro kahata
 
 
 
 //
 //
 // this code open for help
 // people who try to change this world more nice way for us specially people who doing ufo, psychic, psychotronics, crop circle, free energy research and open information act.
 // people who is working this way can use this code for there own purpose with no permission from me with there own risk.
 //
 //
 //
 // IBVA code development short history
 //
 // <IBVA V1.0 beta> 17 oct 1987 : start develop IBVA
 // <IBVA V1.6 beta> 21 oct 1988 : pre prototype
 // <IBVA V1.0> 6 nov 1989 : prototype
 // <IBVA V1.0.2> apr 1991 : start to ship in Japan
 // <IBVA V1.0.5> 5 jan 1992 : start to ship in USA
 // <IBVA V1.8.7>  13 feb 1999 : 68K Think Project Manager 7.0.4
 // <IBVA V2.0.9> 23 jan 2000 : starsBrain & brain skyfly
 // <IBVA V2.3.2> 15 dec 2000 : IDE V4.1, CW V6
 // <IBVA V3.0.0> 26 Sep 2003 : new Icon
 // <IBVA V3.5.0> 29 Nov 2003 : start to use XCODE. V1 prototype Bluetooth IBVA
 // <IBVA V3.6.0> 29 Apr 2004 : V2 prototype Bluetooth IBVA
 // <IBVA V4.0.0> 1 Mar 2005 : Core-MIDI 
 // <IBVA V4.1.0> 17 May 2005 : start to ship IBVA4. XCODE1.5
 // <IBVA V4.1.1> 29 July 2005 : XCODE2.0, Tiger
 // <IBVA V4.1.3> 19 Sep 2005 : XCODE2.2. Quartz Composer Plugin
 // <IBVA V4.2.0> 1 March 2006 : V3 prototype Bluetooth IBVA
 // <IBVA V4.2.6> 5 May 2006 : final prototype Bluetooth IBVA
 // <IBVA V4.4.0> 19 Mar 2007 : XCODE2.4.1.  MIDI play with 0.01 second timing with live video and brain wave recording.
 // <IBVA V4.5.4> 26 Oct 2007 : XCODE3. Leopard.
 // <IBVA V4.5.8> 23 Dec 2007 : QC V3 + XCODE3 + Leopard.
 //
 //
 // this source code is based on my over 35 years of ufo, psychic, dream and brain wave interaction experience, dream and brain wave data analysis & research.
 // thanks to 
 // ayumi, masachan-etsuchan, hiyori, l-chi, paras,
 // alien, beings who working for this planet, this stars system and other stars system,
 // hyper space time dimensions + psychic dimension & dream dimension.
 //
 // need more this kind of experience & research.
 //
 // i need more help to keep continue to do this kind of things,
 // i like happy family, easy way and fun to make it. 
 // need psychic healing,,,
 // need experience for dream, remote viewing, telepathy, psychic, 
 // crop circle, ufo and alien abductee, alien implant, etc....
 */ 



/* It's highly recommended to use CGL macros instead of changing the current context for plug-ins that perform OpenGL rendering */
#import <OpenGL/CGLMacro.h>
#include <Carbon/Carbon.h>

#import "IBVASerialPortOutPlugIn.h"

#include <GLUT/glut.h>

#define	kQCPlugIn_Name				@"Serial OUT"
#define	kQCPlugIn_Description		@"Serial OUT: This trigger update output.  Output Gain: All Output Gain setup.  Output Touch Mode: Set Output Mode. Direct, Normalize by 64:0..1, Normalize by 255:0..1, Normalize 0..1 by BS1..4 Peak, Normalize 0..1 by BS1..8 Peak. Output Control Mode: Set Output Mode. Direct 0..255, Normalize by 255:0..360, Normalize by 255:-360..360, Normalize by 255:0..1, Normalize by Max X,Y,Z:0..1. Brain Channel: Set CH1, CH2, CH3, CH4, Coherence 1/2, Coherence 3/4, Coherence 1/3, Coherence 2/4,  iPhone BS Touch: ON/OFF. iPhone BS Control: ON/OFF.  iPhone Server: ON/OFF. Delta BS1 Touch, Theta BS2 Touch, Alpha BS3 Touch, Low Beta BS4 Touch, Mid Beta BS5 Touch, High Beta BS6 Touch, AC BS7 Touch, Gamma BS8 Touch:  BS Output. Key String Output: String Output, Char Output: Character Output, Rotation X,Y,Z: X, Y, Z Output.  Control: Control Output.  Speed Control:Speed Output.  Volume Control:Volume Output.  Volume Up Signal Control, Volume Down, Previous, Next, Play, Menu, Begin, Stop Signal: each Signal Output. iPhone Auto Connection String: Connection info Output string"

#define true 1
#define false 0


#define GRIDNumber 32


//

//
int bYXbak=0;
int bYYbak=0;
int bYZbak=0;

int XYZiPhoneX=0;
int ABCiPhoneX=0;
float XSlider_valueX;
float YSlider_valueX;
float ZSlider_valueX;
float EyedeltaLSlider_valueX;	// BS1
float EyedeltaHSlider_valueX;	// BS2
float ThetaLSlider_valueX;	// BS3
float ThetaHSlider_valueX;	// BS4
float AlphaLSlider_valueX;	// BS5
float AlphaHSlider_valueX;	// BS6
float BetaLSlider_valueX;	// BS7
float BetaHSlider_valueX;	// BS8
/*
 extern float XSlider_valueX;
 extern float YSlider_valueX;
 extern float ZSlider_valueX;
 extern float EyedeltaLSlider_valueX;	// BS1
 extern float EyedeltaHSlider_valueX;	// BS2
 extern float ThetaLSlider_valueX;	// BS3
 extern float ThetaHSlider_valueX;	// BS4
 extern float AlphaLSlider_valueX;	// BS5
 extern float AlphaHSlider_valueX;	// BS6
 extern float BetaLSlider_valueX;	// BS7
 extern float BetaHSlider_valueX;	// BS8
 */


//
extern	int firstTimeRunAplicationX;
//
//
int firsttimestartServermainloop=1;
int firstTimeRunServer=1;
//
extern int charP;
extern int	nextCharP;
//
extern char Cstr[];


NSInteger	BSModeA;
NSInteger	BSModeB;
NSInteger	BSModeAX;
NSInteger	BSModeBX;
//
#define kGameIdentifier		@"wipsy"
//
float BSoutGain=1.0;
int PeerDisconnected=1;
char bufferInputCX[255];


int inputAutoIphoneConnectionY=0;
int inputTouchBSiPhoneX=0;
int inputXYZBSiPhoneX=0;

//
//
//
/*
pascal void getDataEventLoopTimer(EventLoopTimerRef  inTimer, void *inUserData)
{
	//	if (openPort)
	//		getFromPort();
	
}


void startmainloop(void)	{
	EventLoopTimerUPP	eventLoopTimer;
 	float inDelay=0.005; 
 	float inInterval=0.005;
	EventLoopRef       mainLoop;	
	
 	mainLoop = GetMainEventLoop(); // GetCurrentEventLoop()
	eventLoopTimer = NewEventLoopTimerUPP(getDataEventLoopTimer);
	
 	InstallEventLoopTimer( mainLoop, inDelay,
						  inInterval, eventLoopTimer, NULL, NULL );
	
}

*/


@implementation IBVASerialPortOutPlugIn

/* We need to declare the input / output properties as dynamic as Quartz Composer will handle their implementation */
@dynamic 
inputAutoIphoneConnection, inputXYZBSiPhone, inputTouchBSiPhone, inputChannel, inputBPSMode, inputOutputBSMode, inputDataBitMode, inputUpdate,

outputIPhoneConnectionString,
outputStop, outputBegin, outputMenu, outputPlay, outputNext, outputPrevious, outputVolumeDown,outputVolumeUp, 
outputPeakFR2, outputPeakVR2, outputPeakFL2, outputPeakVL2, outputPeakFR, outputPeakVR, outputPeakFL, outputPeakVL, outputString,
outputBS8L, outputBS7L, outputBS6L, outputBS5L, outputBS4L, outputBS3L, outputBS2L, outputBS1L;


/* The "text" property must be synthesized */
@synthesize text;


+ (NSDictionary*) attributes
{
	/* Return the attributes of this plug-in */
	return [NSDictionary dictionaryWithObjectsAndKeys:kQCPlugIn_Name, QCPlugInAttributeNameKey, kQCPlugIn_Description, QCPlugInAttributeDescriptionKey, nil];
}

+ (NSDictionary*) attributesForPropertyPortWithKey:(NSString*)key
{
    NSArray *titlesBrainChannel = [NSArray arrayWithObjects:
								   @"0: CH 1",
								   @"1: CH 2",
								   @"2: CH 3",
								   @"3: CH 4",
								   @"4: CH 1/2 Coherence",
								   @"5: CH 3/4 Coherence",
								   @"6: CH 1/3 Coherence",
								   @"7: CH 2/4 Coherence",
								   nil];
	
 	NSArray *titlesBPSMode = [NSArray arrayWithObjects:
										 @"Direct : 0..255",
										 @"Normalize by 255 : 0..360",
										 @"Normalize by 255 : -360..360",
										 @"Normalize by 255 : 0..1",
										 @"Normalize by Max X, Y, Z : 0..1",
										 nil];
	
	
	NSArray *titlesMultiPeakPowerBSMode = [NSArray arrayWithObjects:
										   @"Direct",
										   @"Normalize by 64 : 0..1",
										   @"Normalize by 255 : 0..1",
										   @"Normalize 0..1 by BS1..4 Peak",
										   @"Normalize 0..1 by BS1..8 Peak",
										   nil];
	
	
	/* Return the attributes for the plug-in property ports */
	//	if([key isEqualToString:@"inputString"])
	//		return [NSDictionary dictionaryWithObjectsAndKeys:@"Name", QCPortAttributeNameKey, @"Pod", QCPortAttributeDefaultValueKey, nil];
	
	if([key isEqualToString:@"inputAutoIphoneConnection"])
		return [NSDictionary dictionaryWithObject:@"iPhone Server" forKey:QCPortAttributeNameKey];
	
	if([key isEqualToString:@"inputXYZBSiPhone"])
		return [NSDictionary dictionaryWithObject:@"iPhone BS Control" forKey:QCPortAttributeNameKey];
	if([key isEqualToString:@"inputTouchBSiPhone"])
		return [NSDictionary dictionaryWithObject:@"iPhone BS Touch" forKey:QCPortAttributeNameKey];
	
	if([key isEqualToString:@"inputChannel"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Brain Channel", QCPortAttributeNameKey, [NSNumber numberWithUnsignedInteger:7], QCPortAttributeMaximumValueKey, [NSNumber numberWithUnsignedInteger:0], QCPortAttributeDefaultValueKey, [NSArray arrayWithArray:titlesBrainChannel], QCPortAttributeMenuItemsKey,  nil];
	
	if([key isEqualToString:@"inputBPSMode"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Output Control Mode", QCPortAttributeNameKey, [NSNumber numberWithUnsignedInteger:4], QCPortAttributeMaximumValueKey, [NSNumber numberWithUnsignedInteger:0], QCPortAttributeDefaultValueKey, [NSArray arrayWithArray:titlesBPSMode], QCPortAttributeMenuItemsKey,  nil];
	
	if([key isEqualToString:@"inputOutputBSMode"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Output Touch Mode", QCPortAttributeNameKey, [NSNumber numberWithUnsignedInteger:4], QCPortAttributeMaximumValueKey, [NSNumber numberWithUnsignedInteger:0], QCPortAttributeDefaultValueKey, [NSArray arrayWithArray:titlesMultiPeakPowerBSMode], QCPortAttributeMenuItemsKey,  nil];
	
 	if([key isEqualToString:@"inputDataBitMode"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Output Gain", QCPortAttributeNameKey, [NSNumber numberWithDouble:100.0], QCPortAttributeMaximumValueKey, [NSNumber numberWithDouble:1.0], QCPortAttributeDefaultValueKey, nil];
	
	if([key isEqualToString:@"inputUpdate"])
		return [NSDictionary dictionaryWithObject:@"Output Update" forKey:QCPortAttributeNameKey];
	
	//
	
	if([key isEqualToString:@"outputBS8L"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Gamma BS8 Touch", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputBS7L"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"AC BS7 Touch", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputBS6L"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"High Beta BS6 Touch", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputBS5L"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Mid Beta BS5 Touch", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputBS4L"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Low Beta BS4 Touch", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputBS3L"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Alpha BS3 Touch", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputBS2L"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Theta BS2 Touch", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputBS1L"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Delta BS1 Touch", QCPortAttributeNameKey, nil];
	
	if([key isEqualToString:@"outputString"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Key String Output", QCPortAttributeNameKey, nil];
	//	
	if([key isEqualToString:@"outputPeakVL"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Char Output", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputPeakFL"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Rotation X Control", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputPeakVR"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Rotation Y Control", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputPeakFR"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Rotation Z Control", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputPeakVL2"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Control", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputPeakFL2"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Speed Control", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputPeakVR2"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Volume Control", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputPeakFR2"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"--", QCPortAttributeNameKey, nil];
	//
	if([key isEqualToString:@"outputVolumeUp"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Volume Up Signal Control", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputVolumeDown"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Volume Down Signal Control", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputPrevious"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Previous Signal Control", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputNext"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Next Signal Control", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputPlay"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Play Signal Control", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputMenu"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Menu Signal Control", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputBegin"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Begin Signal Control", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"outputStop"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Stop Signal Control", QCPortAttributeNameKey, nil];
	
	if([key isEqualToString:@"outputIPhoneConnectionString"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"iPhone Auto Connection String", QCPortAttributeNameKey, nil];
	
	
	return nil;
}

+ (QCPlugInExecutionMode) executionMode
{
	/* This plug-in is a processor */
	return kQCPlugInExecutionModeProcessor;
}

+ (QCPlugInTimeMode) timeMode
{
	/* This plug-in does not depend on the time (time parameter is completely ignored in the -execute:atTime:withArguments: method) */
	return kQCPlugInTimeModeNone;
}

- (id) init
{
	int i;
	
	
	if(self = [super init]) {
		/* Set a default value for our internal setting */
		self.text = @"Bonjour";
	}
	
	
	return self;
}

- (void) dealloc
{
	/* IMPORTANT: We need to set the property for our internal setting to nil on -dealloc or the property value will leak */
	self.text = nil;
	//
	//
	//
	//
	[super dealloc];
}




// + (NSArray*) plugInKeys
// {
//	/* Return the list of KVC keys corresponding to our internal settings */
//	return [NSArray arrayWithObject:@"text"];
// }

// - (QCPlugInViewController*) createViewController
// {
//	/* Create a QCPlugInViewController to handle the user-interface to edit the our internal settings */
//	return [[QCPlugInViewController alloc] initWithPlugIn:self viewNibName:@"SimpleTextSettings"];
// }



- (void)initializeThred
{
	if (firstTimeRunServer)	{
		[NSThread detachNewThreadSelector:@selector(runSecondarySerialThread:) toTarget:self withObject:nil];
		firstTimeRunServer=0;
	}
	
	
	//	[self init];
}

- (void)runSecondarySerialThread:(id)ignoredObject;
{
    NSAutoreleasePool *pool;
	
    pool = [[NSAutoreleasePool alloc] init];
	
 //  	timerX = [NSTimer timerWithTimeInterval:0.015f target:self selector:@selector(timerUpdate:) userInfo:nil repeats:YES];
//	[[NSRunLoop currentRunLoop] run];
	
    [pool release];
	
}

-(void) NSStringToCX2:(NSString *)NSStringC
{
	if ([ NSStringC  cString ] == nil ) goto UFO;
	
	char  *outCHARX;
	int i=0;
	int slen=strlen([ NSStringC  cString ]);
	
	
 	outCHARX=(char  *)[NSStringC cString];
	
	for (i=0; i<slen; i++)
		bufferInputCX[i]=outCHARX[i];
	
	bufferInputCX[slen]='\0';
	
	goto IFO;
	
UFO:
	bufferInputCX[0]='\0';
	
IFO:
	i=0;
}





- (void) timerUpdate : (NSTimer*) sender
{
	//	EyedeltaLSlider_valueX=EyedeltaLSlider_valueX+1.0;
	
//	if (PeerDisconnected)	{
//	 	[self setup];
//		PeerDisconnected=0;
		//		iPhoneConnectionMessage = @"iPhoneConnectionMessageXXX";
//	}
}



@end





@implementation IBVASerialPortOutPlugIn (Execution)



- (BOOL) startExecution:(id<QCPlugInContext>)context
{
	if (firsttimestartServermainloop)	{
		
		// 	 	startmainloop();
		//	[self initializeThred];
		firsttimestartServermainloop=0;
		
		inputAutoIphoneConnectionX=self.inputAutoIphoneConnection;
		if (self.inputAutoIphoneConnection)	{
		//	[self setupIphoneConnection];
		}
		
		
		inputTouchBSiPhoneX=self.inputTouchBSiPhone;
		if ( self.inputTouchBSiPhone )	{  
			ABCiPhoneX=5;				
		}
		else	{
			ABCiPhoneX=0;
		}
		
		
		inputXYZBSiPhoneX=self.inputXYZBSiPhone;
		if ( self.inputXYZBSiPhone )	{  
			XYZiPhoneX=5;				
		}
		else	{
			XYZiPhoneX=0;
		}
		
		
		
		//	inputXYZBSiPhoneX=self.inputChannel
	}
	
	//
	//
	return YES;
}



- (BOOL) execute:(id<QCPlugInContext>)context atTime:(NSTimeInterval)time withArguments:(NSDictionary*)arguments
{
	
	int mode_value=(int)self.inputOutputBSMode;
	int mode_valueZ=0;
	int mode_BSvalue=(int)self.inputBPSMode;
	int mode_BSvalueZ=0;
	int channel_value=(int)self.inputChannel;	// 0=1ch, 1=2ch, 2=3ch, 3=4ch, 4=ch1/ch2 coherence
	
	double PeakVR, PeakFR, PeakVL, PeakFL;
	double PeakVR2, PeakFR2, PeakVL2, PeakFL2;
	
    double     eyePeakL, deltaPeakL, thetaPeakL, 
	alphaPeakL, lowbetaPeakL, midbetaPeakL, 
	highbetaPeakL, gammaPeakL, acPeakL;
	
	double powerGain=1.0;
	int i;
	double maxA=0.0;
	
	
	//

	
	if (BSModeA>1 ) BSModeA=0;
	
	//	if ( ( self.inputUpdate )	&& ( channel_value == (BSModeA*4)+(BSModeB)) ) {
	if ( ( self.inputUpdate )	&& ( channel_value == (BSModeA*4)+(BSModeB)) ) {
		
		// end of get char and make NSString for out
		//
		int i;
		
		//	self.outputPeakVL = (double)bYb[(GRIDNumber*2)-1];
		
		// bYb[31] is srt length
		
		charP=0;

		Cstr[charP]='\0';
		self.outputString = [NSString stringWithFormat:@"%s", Cstr ];
		
		
		
		//
		
	}	// end of if ( self.inputUpdate )
	
	//
	
	

//	self.outputIPhoneConnectionString = [NSString stringWithFormat:iPhoneConnectionMessage];
	
	
	
	//
	//
	return YES;
}



@end








